package com.zksy.web.controller.basicData;

import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.zksy.common.annotation.Log;
import com.zksy.common.core.controller.BaseController;
import com.zksy.common.core.domain.AjaxResult;
import com.zksy.common.enums.BusinessType;
import com.zksy.common.utils.file.ExcelUtils;
import com.zksy.system.basicData.domain.CrmTaxUrge;
import com.zksy.system.basicData.service.CrmTaxUrgeService;
import com.zksy.utils.DowntemplateUtil;
import com.zksy.utils.SearchUtil;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.multipart.MultipartFile;

import javax.servlet.http.HttpServletResponse;
import java.io.IOException;
import java.util.List;

/**
 * 税务处罚-税务催告Controller
 *
 * @author sy
 * @date 2024-06-03
 */
@RestController
@RequestMapping("/crmTaxUrge")
@Api(tags = "税务处罚-税务催告", description = "税务处罚-税务催告desc")
public class CrmTaxUrgeController extends BaseController{

    @Autowired
    private CrmTaxUrgeService service;

    @GetMapping("/getById/{borrowId}")
    @ApiOperation(value = "税务处罚-税务催告搜索getById")
    public CrmTaxUrge getById(@PathVariable String borrowId) {
        return service.getById(borrowId);
    }

    @GetMapping("/findByPage")
    @ApiOperation(value = "税务处罚-税务催告分页")
    public Page findByPage(long pageNum, long pageSize, String conditionJson) throws Exception {
        return service.page(new Page<>(pageNum, pageSize), SearchUtil.parseWhereSql(conditionJson));
    }

    @GetMapping("/getList")
    @ApiOperation(value = "税务处罚-税务催告查询所有")
    public List<CrmTaxUrge> getList(String conditionJson) throws Exception {
        return service.list(SearchUtil.parseWhereSql(conditionJson));
    }

    /**
     * 新增税务处罚-税务催告
     */
    @PostMapping("/save")
    @ApiOperation(value = "税务处罚-税务催告新增")
    @Log(title = "新增税务处罚-税务催告", businessType = BusinessType.INSERT)
    public boolean save(@RequestBody CrmTaxUrge crmTaxUrge) {
        return service.save(crmTaxUrge);
    }

    /**
     * 修改税务处罚-税务催告
     */
    @PostMapping("/updateById")
    @ApiOperation(value = "税务处罚-税务催告修改")
    @Log(title = "修改税务处罚-税务催告", businessType = BusinessType.UPDATE)
    public boolean updateById(@RequestBody CrmTaxUrge crmTaxUrge) {
        return service.updateById(crmTaxUrge);
    }

    /**
     * 导入税务处罚-税务催告
     */
    @ApiOperation("税务处罚-税务催告导入")
    @Log(title = "税务处罚-税务催告", businessType = BusinessType.IMPORT)
    @PostMapping("/importData")
    public AjaxResult importData(MultipartFile file)
    {
        try {
            List<CrmTaxUrge> crmTaxUrgeAll = service.list();
            List<CrmTaxUrge> list = ExcelUtils.readMultipartFile(file, CrmTaxUrge.class,CrmTaxUrge.class.getDeclaredFields().length - 2);
            if(crmTaxUrgeAll != null && crmTaxUrgeAll.size() > 0){
                //return AjaxResult.error("数据已存在，如需重新导入请清空数据");
            }
            if(list.size() > 0){
                service.saveBatch(list);
                return success("导入成功，共计："+list.size()+"条");
            }else{
                return AjaxResult.error("无数据");
            }
        }catch (Exception e){
            e.printStackTrace();
            return AjaxResult.error("导入数据失败");
        }
    }

    @ApiOperation("税务处罚-税务催告导出")
    @Log(title = "税务处罚-税务催告", businessType = BusinessType.EXPORT)
    @PostMapping("/exportData")
    public AjaxResult exportData(HttpServletResponse response, String conditionJson){
        try {
            List<CrmTaxUrge> wrapperList = service.list(SearchUtil.parseWhereSql(conditionJson));
            ExcelUtils.export(response,"税务处罚-税务催告",wrapperList,CrmTaxUrge.class);
            return AjaxResult.success("导出数据成功");
        }catch (Exception e){
            e.printStackTrace();
            return AjaxResult.error("导出数据失败");
        }
    }

    @Log(title = "税务处罚-税务催告", businessType = BusinessType.DELETE)
    @PostMapping("/delete")
    @ApiOperation(value = "删除税务处罚-税务催告", notes = "删除税务处罚-税务催告")
    public AjaxResult delete(@RequestBody List<String> ids)
    {
        return toAjax(service.removeByIds(ids));
    }

    @DeleteMapping("/deleteAll")
    @ApiOperation(value = "清除数据", notes = "清除数据")
    public AjaxResult deleteAll(){
        return service.deleteAll();
    }

    @PostMapping("/getUploadTemplate")
    @ApiOperation(value = "获取上传模板", notes = "获取上传模板")
    public void getUploadTemplate(HttpServletResponse response) throws IOException {
        DowntemplateUtil.downloadTemplate(response,"税务处罚-税务催告模板");
    }
}

